import cv2  # importation d'open-CV-Python
import numpy
from matplotlib import pyplot as plt

# choix de la source de la caméra (0 pour une webcam intégrée à l'ordinateur, 1 pour une webcam externe sur port USB)
cap = cv2.VideoCapture(1,cv2.CAP_DSHOW)

# initialisation de la résolution (axe X = 1920 px, axe Y = 1080 px)
cap.set(cv2.CAP_PROP_FRAME_WIDTH, 1920)
cap.set(cv2.CAP_PROP_FRAME_HEIGHT, 1080)

ret, img = cap.read()  # retourne une image dans la variable img

cv2.imwrite('image_initiale.png', img)  # enregistre l'image 'img' dans le fichier 'image_intiale.png'
cap.release()  # ferme le flux caméra pour libérer des ressources

# passage de l'image enregistrée en niveaux de gris
img = cv2.imread('image_initiale.png', cv2.IMREAD_GRAYSCALE)

# Calcul de l'histogramme de l'image
hist = cv2.calcHist([img], [0], img, [256], [0,256])

# affichage de l'image et de son histogramme
plt.subplot(211), plt.imshow(img, 'gray')
plt.subplot(212), plt.plot(hist)
plt.xlim([0, 256])

plt.show()
cv2.waitKey(0)  # attend appui sur une touche pour ne plus afficher la fenêtre
cv2.destroyAllWindows()

# affichage de l'image binarisée pour une certaine valeur du seuil
seuil = int(input('valeur du seuillage ? : '))
ret1, gray = cv2.threshold(img, seuil, 255, cv2.THRESH_BINARY)
cv2.imshow('image binaire', gray)  # affiche l'image 'gray' dans la fenêtre 'image binaire'
cv2.waitKey(0)  # attend appui sur une touche pour ne plus afficher la fenêtre

cv2.destroyAllWindows()  # détruit toutes les fenêtres